#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>

#if defined __TURBOC__
#include <dir.h>
#include <alloc.h>
#include <sys\stat.h>
#define OS_MAJOR  (_version & 0xff)
#else
#include <malloc.h>
#include <direct.h>
#include <sys\types.h>
#include <sys\stat.h>

#define fnsplit   _splitpath
#define fnmerge   _makepath

#define MAXPATH   _MAX_PATH
#define MAXDRIVE  _MAX_DRIVE
#define MAXDIR    _MAX_DIR
#define MAXFILE   _MAX_FNAME
#define MAXEXT    _MAX_EXT

#define FA_RDONLY _A_RDONLY
#define FA_HIDDEN _A_HIDDEN
#define FA_SYSTEM _A_SYSTEM
#define FA_ARCH   _A_ARCH

#define findfirst(a,b,c) _dos_findfirst(a,c,b)
#define ffblk find_t

#define OS_MAJOR  _osmajor

#define farmalloc(x)    ((void far *)halloc(x,1))
#define farfree(x)      hfree((void huge *)x)

#define stpcpy(d,s)     (strcpy (d, s), d + strlen (s))

#endif

// Error codes
#define SWAPOUT_ERR			0x0100	// Couldn't find space to swap out
#define FILE_NOT_FOUND		0x0200	// Couldn't find the file to execute
#define DOS_ERROR			0x0300	// DOS error -- lower byte is DOS err number
#define NO_ENVBUFSPACE		0x0400	// Couldn't malloc space for environment table
#define MISALIGNED_OBJ		0x0500	// SPAWN.OBJ can't be the first module linked in.

extern int C_Shell ( char *prog, char *cmdline, unsigned minmem, char
**envp, char swapflags );

// prog  		filename of program to execute
// cmdline 		command line to pass
// minmem 		minimum desired memory to execute program
// envp			environment table (use NULL to create a new copy of the
//				environment table, or use standard variable 'environ'.
// swapflags	OR ('|') the following to select the indicated options.

#define _EXEC       	0x80	// terminate the program after the exec
#define _SWAPPING   	0x01	// swap to memory (if available memory < minmem).
#define _USE_XMS	 	0x02	// if swapping -- attempt to use XMS to swap.
#define _USE_EMS    	0x04	// if swapping -- attempt to use EMS to swap.
#define _USE_DISK	 	0x08	// if swapping -- attempt to use disk to swap.
#define _SAVE_VID	 	0x10	// save video mode and restore on return
#define _SAVE_INT	 	0x20	// save interrupt table and restore on return
#define _SAVE_EMS	 	0x40	// save EMS mapping and restore on return

